//--RFID 
#include <MFRC522.h>//   rfid 
MFRC522 rfid(10, 9); // SDA, RST
int touch = 0;//    -  RFID                                                              //   iarduino_GSM    GSM/GPRS Shield.
int touchOPin = 14;//     RFID  D14(A0)
int relpin = 6;//      D6
//---GSM  
#include <SoftwareSerial.h>
SoftwareSerial SIM800(2, 3); //RX, TX   
int SMSpin = 15;//      .
String _response = "";

void setup() {
  Serial.begin(9600);
  SPI.begin();      //  
  rfid.PCD_Init();  //  
  pinMode(touchOPin, OUTPUT);//
  pinMode(SMSpin, OUTPUT);
  //     
  SIM800.begin(9600);
  pinMode(relpin, OUTPUT);//  SMSpin  
  Serial.println("Initializing...");
  delay(10);

  SIM800.println("AT"); //Once the handshake test is successful, it will back to OK
  updateSerial();
  SIM800.write(26);
  SIM800.println("AT"); //Once the handshake test is successful, it will back to OK
  updateSerial();
  SIM800.write(26);
  SIM800.println("AT"); //Once the handshake test is successful, it will back to OK
  updateSerial();
  SIM800.write(26);
  digitalWrite(relpin, HIGH);//  
  }
void loop() {
  //   
  if (rfid.PICC_IsNewCardPresent() && rfid.PICC_ReadCardSerial())
  {
    touch = touch + 1;//    touch  1
    digitalWrite(relpin, LOW);//  

    Serial.println(touch);//   touch   
    digitalWrite(touchOPin, HIGH);//   touchOPin
    delay(6500);//    

    digitalWrite(touchOPin, LOW);//   touchOPin
    delay(50);
    digitalWrite(relpin, HIGH);//  
  }

  delay(100);

  if (  touch >= 4)//    4 
  {
    digitalWrite(relpin, HIGH);//  
    Serial.println("LImit OFF"); //   LImit OFF   
    touch = 0;//    touch
    ////--
    digitalWrite(SMSpin, HIGH); //  SMSpin
    delay(500);//   
    String strTest = "   ";            // 
    sendSMSinPDU("+79508330781", strTest);              //    
    if (SIM800.available())   {                         //  , - ...
      _response = waitResponse();                       //      
      _response.trim();                                 //       
      Serial.println(_response);                        //      
    }
    if (Serial.available())  {                          //    Serial...
      SIM800.write(Serial.read());                      // ...    
    };
    digitalWrite(SMSpin, LOW);//   SMSpin
  }

  ///---
  //Serial.println(touch);


}
void sendSMSinPDU(String phone, String message)  //     
{
  Serial.println(" : " + message);

  // ============  PDU- =============================================================================================
  //         
  String *ptrphone = &phone;                                    //      
  String *ptrmessage = &message;                                //     

  String PDUPack;                                               //    PDU-
  String *ptrPDUPack = &PDUPack;                                //      PDU-

  int PDUlen = 0;                                               //     PDU-  SCA
  int *ptrPDUlen = &PDUlen;                                     //       PDU-  SCA

  getPDUPack(ptrphone, ptrmessage, ptrPDUPack, ptrPDUlen);      //   PDU-,      SCA

  Serial.println("PDU-pack: " + PDUPack);
  Serial.println("PDU length without SCA:" + (String)PDUlen);

  // ============  PDU- ============================================================================================
  sendATCommand("AT+CMGF=0", true);                             //  PDU-
  sendATCommand("AT+CMGS=" + (String)PDUlen, true);             //   PDU-
  sendATCommand(PDUPack + (String)((char)26), true);            //  PDU-  Ctrl+Z
}

void getPDUPack(String * phone, String * message, String * result, int *PDUlen)
{
  //  SCA    ,    PDU-
  *result += "01";                                //  PDU-type -  00000001b
  *result += "00";                                //  MR (Message Reference)
  *result += getDAfield(phone, true);             //  DA
  *result += "00";                                //  PID (Protocol Identifier)
  *result += "08";                                //  DCS (Data Coding Scheme)
  //*result += "";                                //  VP (Validity Period) -  

  String msg = StringToUCS2(*message);            //    UCS2-

  *result += byteToHexString(msg.length() / 2);   //  UDL (User Data Length).   2,    UCS2-     2 .
  *result += msg;

  *PDUlen = (*result).length() / 2;               //   PDU-   SCA
  *result = "00" + *result;                       //   SCA
}

String getDAfield(String * phone, bool fullnum) {
  String result = "";
  for (int i = 0; i <= (*phone).length(); i++) {  //   
    if (isDigit((*phone)[i])) {
      result += (*phone)[i];
    }
  }
  int phonelen = result.length();                 //    
  if (phonelen % 2 != 0) result += "F";           //    ,  F

  for (int i = 0; i < result.length(); i += 2) {  //     
    char symbol = result[i + 1];
    result = result.substring(0, i + 1) + result.substring(i + 2);
    result = result.substring(0, i) + (String)symbol + result.substring(i);
  }

  result = fullnum ? "91" + result : "81" + result; //    ,  PR
  result = byteToHexString(phonelen) + result;    //   ,  PL

  return result;
}



String sendATCommand(String cmd, bool waiting) {
  String _resp = "";                            //    
  Serial.println(cmd);                          //     
  SIM800.println(cmd);                          //   
  if (waiting) {                                //    ...
    _resp = waitResponse();                     // ... ,    
    //  Echo Mode  (ATE0),   3   
    if (_resp.startsWith(cmd)) {                //     
      _resp = _resp.substring(_resp.indexOf("\r", cmd.length()) + 2);
    }
    Serial.println(_resp);                      //     
  }
  return _resp;                                 //  . ,  
}

String waitResponse() {                         //       
  String _resp = "";                            //    
  long _timeout = millis() + 10000;             //     (10 )
  while (!SIM800.available() && millis() < _timeout)  {}; //   10 ,      , ...
  if (SIM800.available()) {                     //  ,  ...
    _resp = SIM800.readString();                // ...   
  }
  else {                                        //   , ...
    Serial.println("Timeout...");               // ...    ...
  }
  return _resp;                                 // ...  . ,  
}


// ===================================   UCS2    UTF-8 =================================
String UCS2ToString(String s) {                       //   UCS2 
  String result = "";
  unsigned char c[5] = "";                            //    
  for (int i = 0; i < s.length() - 3; i += 4) {       //   4  
    unsigned long code = (((unsigned int)HexSymbolToChar(s[i])) << 12) +    //  UNICODE-   HEX 
                         (((unsigned int)HexSymbolToChar(s[i + 1])) << 8) +
                         (((unsigned int)HexSymbolToChar(s[i + 2])) << 4) +
                         ((unsigned int)HexSymbolToChar(s[i + 3]));
    if (code <= 0x7F) {                               //        
      c[0] = (char)code;
      c[1] = 0;                                       //     
    } else if (code <= 0x7FF) {
      c[0] = (char)(0xC0 | (code >> 6));
      c[1] = (char)(0x80 | (code & 0x3F));
      c[2] = 0;
    } else if (code <= 0xFFFF) {
      c[0] = (char)(0xE0 | (code >> 12));
      c[1] = (char)(0x80 | ((code >> 6) & 0x3F));
      c[2] = (char)(0x80 | (code & 0x3F));
      c[3] = 0;
    } else if (code <= 0x1FFFFF) {
      c[0] = (char)(0xE0 | (code >> 18));
      c[1] = (char)(0xE0 | ((code >> 12) & 0x3F));
      c[2] = (char)(0x80 | ((code >> 6) & 0x3F));
      c[3] = (char)(0x80 | (code & 0x3F));
      c[4] = 0;
    }
    result += String((char*)c);                       //     
  }
  return (result);
}

unsigned char HexSymbolToChar(char c) {
  if      ((c >= 0x30) && (c <= 0x39)) return (c - 0x30);
  else if ((c >= 'A') && (c <= 'F'))   return (c - 'A' + 10);
  else                                 return (0);
}

// ===================================      UCS2 =================================
String StringToUCS2(String s)
{
  String output = "";                                               //    

  for (int k = 0; k < s.length(); k++) {                            //       
    byte actualChar = (byte)s[k];                                   //   
    unsigned int charSize = getCharSize(actualChar);                //    -  .

    //     UTF-8 - 6    ,  7
    char symbolBytes[charSize + 1];                                 //       
    for (int i = 0; i < charSize; i++)  symbolBytes[i] = s[k + i];  //     ,   
    symbolBytes[charSize] = '\0';                                   //   0

    unsigned int charCode = symbolToUInt(symbolBytes);              //  DEC-    
    if (charCode > 0)  {                                            //       HEX-
      //    2    HEX ,       
      output += byteToHexString((charCode & 0xFF00) >> 8) +
                byteToHexString(charCode & 0xFF);
    }
    k += charSize - 1;                                              //      
    if (output.length() >= 280) break;                              //   70 (4    * 70 = 280) , 
  }
  return output;                                                    //  
}

unsigned int getCharSize(unsigned char b) { //    ,   
  //    UTF-8,         
  // 1  0xxxxxxx -    (ASCII    UTF-8) -    ASCII,   
  // 2  110xxxxx -     -    
  // 3  1110xxxx - 3   ..
  // 4  11110xxx
  // 5  111110xx
  // 6  1111110x

  if (b < 128) return 1;             //      ASCII,     

  //            -      .
  //   ,    ,        .
  for (int i = 1; i <= 7; i++) {
    if (((b << i) & 0xFF) >> 7 == 0) {
      return i;
    }
  }
  return 1;
}

unsigned int symbolToUInt(const String & bytes) { //    DEC- 
  unsigned int charSize = bytes.length();         //  ,   
  unsigned int result = 0;
  if (charSize == 1) {
    return bytes[0]; //     ,   
  }
  else  {
    unsigned char actualByte = bytes[0];
    //        1110XXXX -    1110,  XXXX
    //        ,    -  
    //  (  2 ),   0xFF (11111111) -   (>>)     (3 - 110) - 00011111
    result = actualByte & (0xFF >> (charSize + 1)); //  11010001,  11010001&(11111111>>(2+1))=10001
    //      10XXXXXX -     6     
    //     1 ,    :
    result = result << (6 * (charSize - 1)); //  10001,  10001<<(6*(2-1))=10001000000
    //     ,    10XXXXXX,     result    
    for (int i = 1; i < charSize; i++) {
      actualByte = bytes[i];
      if ((actualByte >> 6) != 2) return 0; //      10,   - 
      //   ,     
      // ,  10011111   10 (  ),  - 11111
      //     2-1-1=0   ,     
      result |= ((actualByte & 0x3F) << (6 * (charSize - 1 - i)));
      //  result=10001000000, actualByte=10011111.  actualByte & 0x3F (10011111&111111=11111),   
      //  ""  result: result|11111 (10001000000|11111=10001011111)
    }
    return result;
  }
}
String byteToHexString(byte i) { //        (HEX)
  String hex = String(i, HEX);
  if (hex.length() == 1) hex = "0" + hex;
  hex.toUpperCase();
  return hex;
}
void updateSerial()
{
  delay(500);
  while (Serial.available())
  {
    SIM800.write(Serial.read());//Forward what Serial received to Software Serial Port
  }
  while (SIM800.available())
  {
    Serial.write(SIM800.read());//Forward what Software Serial received to Serial Port
  }
}